use crate::{
    scene::{ui, util},
    session::SessionState,
    APP,
};

/* List Online
**
** Displays a table of recent, ongoing contests.
*/

pub struct SceneListOnline { }
impl crate::prelude::Scene for SceneListOnline {
    fn load()
    {
        let mut app = unsafe {APP.borrow_mut()};
        match &mut *app {
            Some(app) => {
                util::load_mainmenu();
            
                // Create header
                match app.document.create_element("header") {
                    Ok(header) => {

                        // Left-side header
                        match app.document.create_element("section") {
                            Ok(section_left) => {

                                // Button: Start
                                if app.session.state == SessionState::User {
                                    match ui::button(&app.document, "Start", |_e|{ }) {
                                        Ok(button) => { section_left.append_child(&button).ok(); }
                                        Err(_) => { }
                                    }
                                }

                                header.append_child(&section_left).ok();
                            }
                            Err(_) => { }
                        }

                        // Right-side header
                        match app.document.create_element("section") {
                            Ok(section_right) => {

                                // Button: Previous Page
                                match ui::button(&app.document, "◀", |_e|{ }) {
                                    Ok(button) => { section_right.append_child(&button).ok(); }
                                    Err(_) => { }
                                }

                                // Text: Page Number
                                match ui::button(&app.document, "", |_e|{ }) {
                                    Ok(elem) => {
                                        elem.set_id("pn");
                                        section_right.append_child(&elem).ok();
                                    }
                                    Err(_) => { }
                                }

                                // Button: Next Page
                                match ui::button(&app.document, "▶", |_e|{ }) {
                                    Ok(button) => { section_right.append_child(&button).ok(); }
                                    Err(_) => { }
                                }

                            }
                            Err(_) => { }
                        }

                        app.main.append_child(&header).ok();
                    }
                    Err(_) => { }
                }
            }
            None => { }
        }
    }
}
